const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Financial_recordsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const financial_records = await db.financial_records.create(
      {
        id: data.id || undefined,

        record_type: data.record_type || null,
        amount: data.amount || null,
        date: data.date || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await financial_records.setCompany(data.company || null, {
      transaction,
    });

    await financial_records.setCompanies(data.companies || null, {
      transaction,
    });

    return financial_records;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const financial_recordsData = data.map((item, index) => ({
      id: item.id || undefined,

      record_type: item.record_type || null,
      amount: item.amount || null,
      date: item.date || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const financial_records = await db.financial_records.bulkCreate(
      financial_recordsData,
      { transaction },
    );

    // For each item created, replace relation files

    return financial_records;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const financial_records = await db.financial_records.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.record_type !== undefined)
      updatePayload.record_type = data.record_type;

    if (data.amount !== undefined) updatePayload.amount = data.amount;

    if (data.date !== undefined) updatePayload.date = data.date;

    updatePayload.updatedById = currentUser.id;

    await financial_records.update(updatePayload, { transaction });

    if (data.company !== undefined) {
      await financial_records.setCompany(
        data.company,

        { transaction },
      );
    }

    if (data.companies !== undefined) {
      await financial_records.setCompanies(
        data.companies,

        { transaction },
      );
    }

    return financial_records;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const financial_records = await db.financial_records.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of financial_records) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of financial_records) {
        await record.destroy({ transaction });
      }
    });

    return financial_records;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const financial_records = await db.financial_records.findByPk(id, options);

    await financial_records.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await financial_records.destroy({
      transaction,
    });

    return financial_records;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const financial_records = await db.financial_records.findOne(
      { where },
      { transaction },
    );

    if (!financial_records) {
      return financial_records;
    }

    const output = financial_records.get({ plain: true });

    output.company = await financial_records.getCompany({
      transaction,
    });

    output.companies = await financial_records.getCompanies({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userCompanies = (user && user.companies?.id) || null;

    if (userCompanies) {
      if (options?.currentUser?.companiesId) {
        where.companiesId = options.currentUser.companiesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.companies,
        as: 'company',
      },

      {
        model: db.companies,
        as: 'companies',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.record_type) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'financial_records',
            'record_type',
            filter.record_type,
          ),
        };
      }

      if (filter.amountRange) {
        const [start, end] = filter.amountRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            amount: {
              ...where.amount,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            amount: {
              ...where.amount,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.dateRange) {
        const [start, end] = filter.dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            date: {
              ...where.date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            date: {
              ...where.date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.company) {
        const listItems = filter.company.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          companyId: { [Op.or]: listItems },
        };
      }

      if (filter.companies) {
        const listItems = filter.companies.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          companiesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.companiesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.financial_records.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('financial_records', 'record_type', query),
        ],
      };
    }

    const records = await db.financial_records.findAll({
      attributes: ['id', 'record_type'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['record_type', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.record_type,
    }));
  }
};
